package formes;

import java.awt.geom.Point2D;
import java.util.Objects;

public class Rectangle extends FormeAbstraite {
	private double hauteur;

	private double largeur;

	public Rectangle(Point2D p, double hauteur, double largeur) {
		super(p);
		this.hauteur = hauteur;
		this.largeur = largeur;
	}

	public double hauteur() {
		return hauteur;
	}

	public double largeur() {
		return largeur;
	}

	public double perimetre() {
		return 2. * (hauteur + largeur);
	}

	public double surface() {
		return hauteur * largeur;
	}

	public void changerHauteur(double nouvelleHauteur) {
		hauteur = nouvelleHauteur;
	}

	public void changerLargeur(double nouvelleLargeur) {
		largeur = nouvelleLargeur;
	}

	public String toString() {
		return super.toString() + " de largeur " + largeur
				+ " et de hauteur " + hauteur;
	}

	public boolean equals(Object o) {
		if (!(o instanceof Rectangle))
			return false;
		Rectangle r = (Rectangle) o;
		return centreGravite.equals(r.centreGravite) && hauteur == r.hauteur && largeur == r.largeur;
	}

	public int hashCode() {
		return Objects.hash(centreGravite, largeur, hauteur);
	}
}